<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackagesCodeList ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackagesCodeList extends AbstractStructArrayBase
{
    /**
     * The Package
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackagesCodeList[]
     */
    public $Package;
    /**
     * Constructor method for ArrayOfJP_PackagesCodeList
     * @uses ArrayOfJP_PackagesCodeList::setPackage()
     * @param \StructType\JP_PackagesCodeList[] $package
     */
    public function __construct(array $package = array())
    {
        $this
            ->setPackage($package);
    }
    /**
     * Get Package value
     * @return \StructType\JP_PackagesCodeList[]|null
     */
    public function getPackage()
    {
        return $this->Package;
    }
    /**
     * This method is responsible for validating the values passed to the setPackage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageForArrayConstraintsFromSetPackage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackagesCodeListPackageItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackagesCodeListPackageItem instanceof \StructType\JP_PackagesCodeList) {
                $invalidValues[] = is_object($arrayOfJP_PackagesCodeListPackageItem) ? get_class($arrayOfJP_PackagesCodeListPackageItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackagesCodeListPackageItem), var_export($arrayOfJP_PackagesCodeListPackageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Package property can only contain items of type \StructType\JP_PackagesCodeList, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Package value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackagesCodeList[] $package
     * @return \ArrayType\ArrayOfJP_PackagesCodeList
     */
    public function setPackage(array $package = array())
    {
        // validation for constraint: array
        if ('' !== ($packageArrayErrorMessage = self::validatePackageForArrayConstraintsFromSetPackage($package))) {
            throw new \InvalidArgumentException($packageArrayErrorMessage, __LINE__);
        }
        $this->Package = $package;
        return $this;
    }
    /**
     * Add item to Package value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackagesCodeList $item
     * @return \ArrayType\ArrayOfJP_PackagesCodeList
     */
    public function addToPackage(\StructType\JP_PackagesCodeList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackagesCodeList) {
            throw new \InvalidArgumentException(sprintf('The Package property can only contain items of type \StructType\JP_PackagesCodeList, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Package[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Package
     */
    public function getAttributeName()
    {
        return 'Package';
    }
}
